## Controller Python Script "steptask_emailtargets"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=state
##title=Email action targets
##

from Products.eCampaigning import ProductMessageFactory as _

TARGET_EMAIL_ENCODING = "utf-8"

action = context.aq_parent
recordcontainer = action.getRecordContainer()

actiontype = action.getActiontype()

record_path = context.REQUEST.SESSION['record_path']
record = context.restrictedTraverse(record_path)

supporter_email = "%s <%s>" % (record.getFullName(), record.emailaddress)
message_subject = record.getSubject()

msg_tmpl = action.getMessagetemplate()
# not used???
#editablemsg = action.getAction_message_modifiable()

try:
   tmpl_msgtype = msg_tmpl.getField("text").getContentType(msg_tmpl)
except AttributeError, e:
   errmsg = "Action not configured: the Action Message for this Action needs to be configured: %s" % e
   return state.set(status="failure", portal_status_message=errmsg)

thankyou_email_template = action.getThankyouemail().aq_inner
try:
   thankyou_subject = thankyou_email_template.getMessagetitle()
except AttributeError, e:
   errmsg = "Action not configured: the thank-you email message for this Action needs to be configured"
   return state.set(status="failure", portal_status_message=errmsg)

# getRawText would bypass data merge
# for html content, we want to invoke uid transformation (kupu)
# for text, we don't want ANY transformation
thankyou_messagefield = thankyou_email_template.getField("text")
thankyou_messagetype = thankyou_messagefield.getContentType(thankyou_email_template)

msg_getter = getattr(thankyou_email_template, thankyou_messagefield.accessor)

if thankyou_messagetype == "text/plain":
   thankyou_message = msg_getter(mimetype="text/plain")
else:
   # resort to default output (see schema)
   thankyou_message = msg_getter()

thankyou_from = action.getThankyouemailname() + " <" + action.getThankyouemailfrom() + ">"

# APPEND A COPY OF THE MESSAGE (optionally) 
# If thanks message is plaintext, transform action message to plaintext if it's HTML
# If thanks message is HTML, do not transform plaintext action message to HTML
# (instead do manual inclusion, see below)

if context.getThankyouemail_includemessage():
   
   # set divider
   msgid = "label_%s_thanksemail_copydivider" % context.sanitizedTypeName(typename=actiontype)
   i18ndivider = context.translate(_(msgid), domain="ecampaigning")
   divider = "\n\n%s\n\n" % i18ndivider

   if thankyou_messagetype == "text/plain":
      attach_msg = record.getMessage(mimetype="text/plain")
      thankyou_message += "\n\n%s\n\n%s\n\n%s" % (divider, message_subject, attach_msg)
      
   elif thankyou_messagetype == "text/html":
      divider = "<br/>%s<br/>" % divider
      if tmpl_msgtype == "text/plain":
         attach_msg = "<pre>%s</pre>" % record.getMessage(mimetype="text/plain")
      else:
         attach_msg = record.getMessage(mimetype="text/x-html-captioned")
      thankyou_message += "%s\n<p><b>%s</b></p>\n%s" % (divider, message_subject, attach_msg)
      
   else:
      errmsg ="can just handle html and plaintext thankyou messages"
      return state.set(status="failure", portal_status_message=errmsg)

# SEND THE MESSAGE

try:
   context.MailHost.secureSend(
      thankyou_message,
      supporter_email,
      thankyou_from,
      subject=thankyou_subject,
      subtype=thankyou_messagetype.split('/')[1],
      charset=TARGET_EMAIL_ENCODING,
   )
except Exception, e:
   errmsg = "email to %s with subject '%s' failed: %s" % (supporter_email, thankyou_subject, e)
   return state.set(status="failure", portal_status_message=errmsg)

   
return state
