## Controller Python Script "steptask_storetrackinginfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=state
##title=Store user tracking information
##

from Products.PythonScripts.standard import url_unquote

REQUEST = context.REQUEST
session = REQUEST.SESSION

record_container = context.getRecordContainer()

try:
   record_path = session["record_path"]
   record = context.restrictedTraverse(record_path)
except:
   from Products.eCampaigning import ProductMessageFactory as _
   errmsg = _("step_error_no_record")
   return state.set(status="failure", portal_status_message=errmsg)
   
# useragent and -ip address; try non-proxied request variable, then squid-proxied, finally apache-proxied
user_ip = REQUEST.get("REMOTE_ADDR") or REQUEST.get("X_FORWARDED_FOR") or REQUEST.get("HTTP_X_FORWARDED_FOR")
record.manage_addProperty("ip_address", user_ip, "string")

record.manage_addProperty("user_agent", REQUEST["HTTP_USER_AGENT"], "string")
record.manage_addProperty("user_agent_languages", REQUEST["HTTP_ACCEPT_LANGUAGE"], "string")

# time and date
record.manage_addProperty("datetime", DateTime(), "date")

# url tracking
record.manage_addProperty("origin_url", session.get('origin_url',''), "string")
record.manage_addProperty("onsite_origin_url", session.get('onsite_origin_url'),"string")

entry_url = session.get("entry_url", "")
record.manage_addProperty("entry_url", entry_url, "string")

# 
# THE URL PARAMETER NAME - ACTION RECORD PARAMETER NAME MAPPING
#
# REF http://www.fairsay.com/labs/standards/AdvocacyTracking
# REF http://www.fairsay.com/labs/ectool/docs/Tracking#query-string-tracking

mappingtable = {
   's':'tracked_source',
   'm':'tracked_medium',
   'p':'tracked_person',
   'c':'tracked_content',
   't':'tracked_terms',
   'n':'tracked_name'
}

## IF THERE'S A QUERY STRING, PROCESS IT
if '?' in  entry_url:
   queryvars = entry_url.split('?')[1].split('&')
   pairs = dict([pair.split('=') for pair in queryvars])
   trackingvars = dict([(mappingtable[name], url_unquote(pairs[name])) for name in pairs if name in mappingtable])
   
   ## STORE THE TRACKING VARS, PLUS SIGN - SEPARATED TERMS FIRST
   try:
      VAR = "tracked_terms"
      terms = trackingvars[VAR].replace('+','\n')      
      record.manage_addProperty(VAR, terms, "lines")
      del trackingvars[VAR]
   except:
      pass
      
   # rest of them
   for k in trackingvars:
      record.manage_addProperty(k, trackingvars[k], "string")
   
return state
